Index: palm/trunk/SOURCE/palm.f90
===================================================================
--- palm/trunk/SOURCE/palm.f90	(revision 4901)
+++ palm/trunk/SOURCE/palm.f90	(revision 1)
@@ -1,80 +1,70 @@
-! !> @file palm.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------------------------!
-!
-! Current revisions:
+#if defined( __vtk )
+ SUBROUTINE palm
+#else
+ PROGRAM palm
+#endif
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
 ! -----------------
-!
+! TEST: open(9)
 !
 ! Former revisions:
 ! -----------------
-! $Id$
-! file re-formatted to follow the PALM coding standard
-!
-! 4539 2020-05-18 14:05:17Z raasch
-! log point name changed
-!
-! 4535 2020-05-15 12:07:23Z raasch
-! bugfix for restart data format query
-!
-! 4496 2020-04-15 08:37:26Z raasch
-! bugfix: coupling character added to restart output filename
-!
-! 4495 2020-04-13 20:11:20Z raasch
-! restart data handling with MPI-IO added
-!
-! 4457 2020-03-11 14:20:43Z raasch
-! use statement for exchange horiz added
-!
-! 4444 2020-03-05 15:59:50Z raasch
-! bugfix: cpp-directives for serial mode added
-!
-! 4414 2020-02-19 20:16:04Z suehring
-! Call to module_interface_init_numerics
-!
-! 4400 2020-02-10 20:32:41Z suehring
-! Add interface to initialize data output with dom
-!
-! 4360 2020-01-07 11:25:50Z suehring
-! implement new palm_date_time_mod
-!
-! 4094 2019-07-12 09:24:21Z gronemeier
-! Corrected "Former revisions" section
-!
-! 4039 2019-06-18 10:32:41Z suehring
-! Rename subroutines in module for diagnostic quantities
-!
-! 4017 2019-06-06 12:16:46Z schwenkel
-! new module for calculation and output of diagnostic quantities added
-!
-! 3885 2019-04-11 11:29:34Z kanani
-! Changes related to global restructuring of location messages and introduction
-! of additional debug messages
-!
-! 3761 2019-02-25 15:31:42Z raasch
-! unused variable removed
-!
-! 3719 2019-02-06 13:10:18Z kanani
-! Included cpu measurement for wall/soil spinup
-!
-! 3703 2019-01-29 16:43:53Z knoop
-! Some interface calls moved to module_interface + cleanup
-!
-! 3648 2019-01-02 16:35:46Z suehring
-! Rename subroutines for surface-data output
+! $Log: palm.f90,v $
+! Revision 1.10  2006/08/04 14:53:12  raasch
+! Distibution of run description header removed, call of header moved behind
+! init_3d_model
+!
+! Revision 1.9  2006/02/23 12:44:43  raasch
+! plot_.. renamed data_output_..
+!
+! Revision 1.8  2004/04/30 12:31:07  raasch
+! Missing cpp-instructions added, leap_frog changed to time_integration
+!
+! Revision 1.7  2003/05/09 14:46:49  raasch
+! String converted to integer before send via broadcast due to Linux MPICH
+! problem
+!
+! Revision 1.6  2003/03/16 09:42:17  raasch
+! Two underscores (_) are placed in front of all define-strings
+!
+! Revision 1.5  2002/12/19 15:53:59  raasch
+! Routine local_tremain_ini moved from init_3d_model to here
+!
+! Revision 1.4  2001/08/21 09:53:35  raasch
+! comm_palm is now used as the global communicator since one PE maybe split from
+! MPI_COMM_WORLD for usage in dvrp-graphics
+!
+! Revision 1.3  2001/03/30 07:39:41  raasch
+! Translation of remaining German identifiers (variables, subroutines, etc.),
+! closing of unit 14 moved from routine write_3d_binary to this routine
+!
+! Revision 1.2  2001/01/25 07:15:06  raasch
+! Program name changed to PALM, module test_variables removed.
+! Initialization of dvrp logging as well as exit of dvrp moved to new
+! subroutines init_dvrp_logging and close_dvrp (file init_dvrp.f90)
+!
+! Revision 1.23  2001/01/05 15:13:51  raasch
+! +module spectrum
+!
+! Revision 1.22  2001/01/02 17:32:55  raasch
+! Subroutine close_files renamed to close_file, now called with an argument
+!
+! Revision 1.21  2000/12/28 13:32:16  raasch
+! Call of MPI_FINALIZE moved to the end of the program. At the beginning
+! comm2d is set to MPI_COMM_WORLD (it was undefined before).
+! Call of write_particles at the end. Open and close of DVRP-Software at the
+! beginning and at the end (optionally, by cpp-directives)
+!
+! Revision 1.20  2000/04/27 06:42:43  raasch
+! closing call to dvrp-software (if used) at the end of the run,
+! old revision remarks deleted
+!
+! Revision 1.19  2000/01/25 15:29:23  letzel
+! All comments translated into English
+!
+! Revision 1.18  1999/11/25 16:27:49  raasch
+! Bei Benutzung von VTK-Grafik wird Modell als UP in C++ - Programm eingebunden
 !
 ! Revision 1.1  1997/07/24 11:23:35  raasch
@@ -84,170 +74,43 @@
 ! Description:
 ! ------------
-!> Large-Eddy Simulation (LES) model for atmospheric and oceanic boundary-layer flows,
-!> see the PALM homepage https://palm-model.org for further information
-!--------------------------------------------------------------------------------------------------!
- PROGRAM palm
+! Large-Eddy Simulation (LES) model for the convective boundary layer, 
+! optimized for use on parallel machines (implementation realized using the
+! Message Passing Interface (MPI)). The model can also be run on vector machines
+! (less well optimized) and workstations. Versions for the different types of 
+! machines are controlled via cpp-directives.
+! Model runs are only feasible using the ksh-script mrun.
+!------------------------------------------------------------------------------!
 
 
     USE arrays_3d
+    USE constants
+    USE cpulog
+    USE dvrp_variables
+    USE grid_variables
+    USE indices
+    USE interfaces
+    USE model_1d
+    USE particle_attributes
+    USE pegrid
+    USE spectrum
+    USE statistics
+    USE control_parameters
+
+    IMPLICIT NONE
+
+!
+!-- Local variables
+    CHARACTER (LEN=9) ::  time_to_string
+    CHARACTER (LEN=1) ::  cdum
+    INTEGER           ::  i, run_description_header_i(80)
 
 #if defined( __parallel )
-    USE bulk_cloud_model_mod,                                                                      &
-        ONLY: bulk_cloud_model, microphysics_morrison, microphysics_seifert
-#endif
-
-    USE control_parameters,                                                                        &
-        ONLY:  coupling_char, do2d_at_begin, do3d_at_begin, io_blocks, io_group, message_string,   &
-               restart_data_format_output, runnr, simulated_time_chr, spinup,                      &
-               time_since_reference_point, user_interface_current_revision,                        &
-               user_interface_required_revision, version, write_binary
-
-#if defined( __parallel )
-    USE control_parameters,                                                                        &
-        ONLY:  child_domain, constant_diffusion, humidity, initializing_actions, neutral,          &
-               passive_scalar
-#endif
-
-    USE cpulog,                                                                                    &
-        ONLY:  cpu_log, cpu_statistics, log_point
-
-#if defined( __parallel )
-    USE cpulog,                                                                                    &
-        ONLY:  log_point_s
-#endif
-
-    USE diagnostic_output_quantities_mod,                                                          &
-        ONLY:  doq_calculate
-
-#if defined( __parallel )
-    USE exchange_horiz_mod,                                                                        &
-        ONLY:  exchange_horiz
-
-    USE indices,                                                                                   &
-        ONLY:  nbgp
-#endif
-
-    USE kinds
-
-    USE module_interface,                                                                          &
-        ONLY:  module_interface_init_numerics,                                                     &
-               module_interface_init_output,                                                       &
-               module_interface_last_actions
-
-
-    USE multi_agent_system_mod,                                                                    &
-        ONLY:  agents_active, mas_last_actions
-
-    USE netcdf_data_input_mod,                                                                     &
-        ONLY:  netcdf_data_input_inquire_file, netcdf_data_input_init,                             &
-               netcdf_data_input_surface_data, netcdf_data_input_topo
-
-    USE pegrid
-
-#if defined( __parallel )
-    USE pmc_particle_interface,                                                                    &
-        ONLY: pmcp_g_alloc_win
-
-    USE pmc_interface,                                                                             &
-        ONLY:  nested_run, pmci_child_initialize, pmci_init, pmci_modelconfiguration,              &
-               pmci_parent_initialize
-#endif
-
-    USE restart_data_mpi_io_mod,                                                                   &
-        ONLY:  rd_mpi_io_close, rd_mpi_io_open
-
-    USE surface_data_output_mod,                                                                   &
-        ONLY:  surface_data_output_last_action
-
-    USE write_restart_data_mod,                                                                    &
-        ONLY:  wrd_global, wrd_local
-
-#if defined( __parallel )  &&  defined( _OPENACC )
-    USE openacc
-#endif
-
-
-    IMPLICIT NONE
-
-!
-!-- Local variables
-    CHARACTER(LEN=9) ::  time_to_string  !<
-
-    INTEGER(iwp)     ::  i                   !< loop counter for blocked I/O
-#if defined( __parallel) && defined( _OPENACC )
-    INTEGER(acc_device_kind) :: device_type      !< device type for OpenACC
-    INTEGER(iwp)             :: local_comm       !< local communicator (shared memory)
-    INTEGER(iwp)             :: local_num_procs  !< local number of processes
-    INTEGER(iwp)             :: local_id         !< local id
-    INTEGER(iwp)             ::  num_devices     !< number of devices visible to OpenACC
-    INTEGER(iwp)             ::  my_device       !< device used by this process
-#endif
-
-    version = 'PALM 6.0'
-    user_interface_required_revision = 'r4495'
-
-#if defined( __parallel )
-!
-!-- MPI initialisation. comm2d is preliminary set, because it will be defined in init_pegrid but is
-!-- used before in cpu_log.
+!
+!-- MPI initialisation. comm2d is preliminary set, because
+!-- it will be defined in init_pegrid but is used before in cpu_log.
     CALL MPI_INIT( ierr )
-
-!
-!-- Initialize the coupling for nested-domain runs comm_palm is the communicator which includes all
-!-- PEs (MPI processes) available for this (nested) model. If it is not a nested run, comm_palm is
-!-- returned as MPI_COMM_WORLD.
-    CALL cpu_log( log_point_s(70), 'pmci_init', 'start' )
-    CALL pmci_init( comm_palm )
-    CALL cpu_log( log_point_s(70), 'pmci_init', 'stop' )
-    comm2d = comm_palm
-!
-!-- Get the (preliminary) number of MPI processes and the local PE-id (in case of a further
-!-- communicator splitting in init_coupling, these numbers will be changed in init_pegrid).
-    IF ( nested_run )  THEN
-
-       CALL MPI_COMM_SIZE( comm_palm, numprocs, ierr )
-       CALL MPI_COMM_RANK( comm_palm, myid, ierr )
-
-    ELSE
-
-       CALL MPI_COMM_SIZE( MPI_COMM_WORLD, numprocs, ierr )
-       CALL MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
-!
-!--    Initialize PE topology in case of coupled atmosphere-ocean runs (comm_palm will be splitted
-!--    in init_coupling)
-       CALL init_coupling
-    ENDIF
-
-#ifdef _OPENACC
-!
-!-- Select OpenACC device to use in this process. For this find out how many neighbors there are
-!-- running on the same node and which id this process is.
-    IF ( nested_run )  THEN
-       CALL MPI_COMM_SPLIT_TYPE( comm_palm, MPI_COMM_TYPE_SHARED, 0, MPI_INFO_NULL, local_comm,    &
-                                 ierr )
-    ELSE
-       CALL MPI_COMM_SPLIT_TYPE( MPI_COMM_WORLD, MPI_COMM_TYPE_SHARED, 0, MPI_INFO_NULL,           &
-                                 local_comm, ierr )
-    ENDIF
-    CALL MPI_COMM_SIZE( local_comm, local_num_procs, ierr )
-    CALL MPI_COMM_RANK( local_comm, local_id, ierr )
-
-!
-!-- This loop including the barrier is a workaround for PGI compiler versions up to and including
-!-- 18.4. Later releases are able to select their GPUs in parallel, without running into spurious
-!-- errors.
-    DO i = 0, local_num_procs-1
-       CALL MPI_BARRIER( local_comm, ierr )
-
-       IF ( i == local_id )  THEN
-          device_type = acc_get_device_type()
-          num_devices = acc_get_num_devices( device_type )
-          my_device = MOD( local_id, num_devices )
-          CALL acc_set_device_num( my_device, device_type )
-       ENDIF
-    ENDDO
-
-    CALL MPI_COMM_FREE( local_comm, ierr )
-#endif
+    CALL MPI_COMM_SIZE( MPI_COMM_WORLD, numprocs, ierr )
+    comm_palm = MPI_COMM_WORLD
+    comm2d    = MPI_COMM_WORLD
 #endif
 
@@ -262,15 +125,12 @@
 
 !
-!-- Open a file for debug output
-    WRITE (myid_char,'(''_'',I6.6)')  myid
-    OPEN( 9, FILE='DEBUG'//TRIM( coupling_char )//myid_char, FORM='FORMATTED' )
-
-!
-!-- Initialize dvrp logging. Also, one PE maybe split from the global communicator for doing the
-!-- dvrp output. In that case, the number of PEs available for PALM is reduced by one and
-!-- communicator comm_palm is changed respectively.
+!-- Initialize dvrp logging. Also, one PE maybe split from the global
+!-- communicator for doing the dvrp output. In that case, the number of
+!-- PEs available for PALM is reduced by one and communicator comm_palm
+!-- is changed respectively.
 #if defined( __parallel )
     CALL MPI_COMM_RANK( comm_palm, myid, ierr )
 #endif
+    CALL init_dvrp_logging
 
 !
@@ -279,87 +139,19 @@
 
 !
-!-- Check for the user's interface version
-    IF ( user_interface_current_revision /= user_interface_required_revision )  THEN
-       message_string = 'current user-interface revision "' //                                     &
-                        TRIM( user_interface_current_revision ) // '" does ' //                    &
-                        'not match the required revision ' //                                      &
-                        TRIM( user_interface_required_revision )
-        CALL message( 'palm', 'PA0169', 1, 2, 0, 6, 0 )
-    ENDIF
-
-!
 !-- Determine processor topology and local array indices
     CALL init_pegrid
-!
-!-- Check if input file according to input-data standard exists
-    CALL netcdf_data_input_inquire_file
-!
-!-- Read topography input data if required. This is required before the numerical grid is finally
-!-- created in init_grid.
-    CALL netcdf_data_input_topo
-!
-!-- Generate grid parameters, initialize generic topography and further process topography
-!-- information if required.
+
+!
+!-- Generate grid parameters
     CALL init_grid
-!
-!-- Initialize boundary conditions and numerics such as the multigrid solver or the advection
-!-- routine
-    CALL module_interface_init_numerics
-!
-!-- Read global attributes if available.
-    CALL netcdf_data_input_init
-!
-!-- Read surface classification data, e.g. vegetation and soil types, water surfaces, etc., if
-!-- available. Some of these data is required before check parameters is invoked.
-    CALL netcdf_data_input_surface_data
+
 !
 !-- Check control parameters and deduce further quantities
     CALL check_parameters
 
+    OPEN( 9, FILE='DEBUG'//myid_char, FORM='FORMATTED' )
+!
+!-- Initialize all necessary variables
     CALL init_3d_model
-
-    CALL module_interface_init_output
-
-#if defined( __parallel )
-!
-!-- Coupling protocol setup for nested-domain runs
-    IF ( nested_run )  THEN
-       CALL pmci_modelconfiguration
-!
-!--    Receive and interpolate initial data on children.
-!--    Child initialization must be made first if the model is both child and parent if necessary.
-       IF ( TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
-          CALL pmci_child_initialize
-!
-!--       Send initial condition data from parent to children
-          CALL pmci_parent_initialize
-!
-!--       Exchange_horiz is needed after the nest initialization
-          IF ( child_domain )  THEN
-             CALL exchange_horiz( u, nbgp )
-             CALL exchange_horiz( v, nbgp )
-             CALL exchange_horiz( w, nbgp )
-             IF ( .NOT. neutral )  THEN
-                CALL exchange_horiz( pt, nbgp )
-             ENDIF
-             IF ( .NOT. constant_diffusion )  CALL exchange_horiz( e, nbgp )
-             IF ( humidity )  THEN
-                CALL exchange_horiz( q, nbgp )
-                IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
-                  CALL exchange_horiz( qc, nbgp )
-                  CALL exchange_horiz( nc, nbgp )
-                ENDIF
-                IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
-                   CALL exchange_horiz( qr, nbgp )
-                   CALL exchange_horiz( nr, nbgp )
-                ENDIF
-             ENDIF
-             IF ( passive_scalar )  CALL exchange_horiz( s, nbgp )
-          ENDIF
-       ENDIF
-
-       CALL pmcp_g_alloc_win                    ! Must be called after pmci_child_initialize and pmci_parent_initialize
-    ENDIF
-#endif
 
 !
@@ -370,117 +162,45 @@
 
 !
-!-- Integration of the non-atmospheric equations (land surface model, urban surface model)
-    IF ( spinup )  THEN
-       CALL cpu_log( log_point(41), 'wall/soil spinup', 'start' )
-       CALL time_integration_spinup
-       CALL cpu_log( log_point(41), 'wall/soil spinup', 'stop' )
-    ENDIF
-
-!
 !-- Set start time in format hh:mm:ss
-    simulated_time_chr = time_to_string( time_since_reference_point )
+    simulated_time_chr = time_to_string( simulated_time )
 
 !
 !-- If required, output of initial arrays
     IF ( do2d_at_begin )  THEN
-       CALL doq_calculate    !TODO, will be called twice
-
        CALL data_output_2d( 'xy', 0 )
        CALL data_output_2d( 'xz', 0 )
        CALL data_output_2d( 'yz', 0 )
     ENDIF
-
     IF ( do3d_at_begin )  THEN
-       CALL doq_calculate    !TODO, will be called twice
-
        CALL data_output_3d( 0 )
     ENDIF
 
 !
-!-- Integration of the model equations using timestep-scheme
+!-- Integration of the model equations using the leap-frog scheme
     CALL time_integration
 
 !
-!-- If required, write binary data for restart runs
-    IF ( write_binary )  THEN
-
-       CALL cpu_log( log_point(22), 'write-restart-data', 'start' )
-
-       CALL location_message( 'writing restart data', 'start' )
-
-       IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
-
-          DO  i = 0, io_blocks-1
-             IF ( i == io_group )  THEN
-
-!
-!--             Open binary file
-                CALL check_open( 14 )
-!
-!--             Write control parameters and other global variables for restart.
-                IF ( myid == 0 )  CALL wrd_global
-!
-!--             Write processor specific flow field data for restart runs
-                CALL wrd_local
-!
-!--             Close binary file
-                CALL close_file( 14 )
-
-             ENDIF
-#if defined( __parallel )
-             CALL MPI_BARRIER( comm2d, ierr )
-#endif
-          ENDDO
-
-       ELSEIF ( restart_data_format_output(1:3) == 'mpi' )  THEN
-!
-!--       Open MPI-IO restart file
-          CALL rd_mpi_io_open( 'write', 'BINOUT' // TRIM( coupling_char ) )
-!
-!--       Write control parameters and other global variables for restart.
-          CALL wrd_global
-!
-!--       Write processor specific flow field data for restart runs
-          CALL wrd_local
-!
-!--       Close restart File
-          CALL rd_mpi_io_close
-
-       ENDIF
-
-       CALL location_message( 'writing restart data', 'finished' )
-
-       CALL cpu_log( log_point(22), 'write-restart-data', 'stop' )
-
-    ENDIF
-!
-!-- Last actions for surface output, for instantaneous and time-averaged data
-    CALL surface_data_output_last_action( 0 )
-    CALL surface_data_output_last_action( 1 )
+!-- If required, write binary data for model continuation runs
+    IF ( write_binary(1:4) == 'true' )  CALL write_3d_binary
+
+!
+!-- If required, write binary particle data
+    CALL write_particles
 
 !
 !-- If required, repeat output of header including the required CPU-time
     IF ( myid == 0 )  CALL header
-!
-!-- Perform module specific last actions
+
+!
+!-- If required, final user-defined actions, and
+!-- last actions on the open files and close files. Unit 14 was opened
+!-- in write_3d_binary but it is closed here, to allow writing on this
+!-- unit in routine user_last_actions.
     CALL cpu_log( log_point(4), 'last actions', 'start' )
-
-    IF ( myid == 0 .AND. agents_active )  CALL mas_last_actions ! ToDo: move to module_interface
-
-    CALL module_interface_last_actions
-
+    CALL user_last_actions
+    IF ( write_binary(1:4) == 'true' )  CALL close_file( 14 )
+    CALL close_file( 0 )
+    CALL close_dvrp
     CALL cpu_log( log_point(4), 'last actions', 'stop' )
-
-!
-!-- Close files
-    CALL close_file( 0 )
-
-!
-!-- Write run number to file (used by palmrun to create unified cycle numbers for output files).
-    IF ( myid == 0  .AND.  runnr > 0 )  THEN
-       OPEN( 90, FILE='RUN_NUMBER', FORM='FORMATTED' )
-       WRITE( 90, '(I4)' )  runnr
-       CLOSE( 90 )
-    ENDIF
 
 !
@@ -493,3 +213,9 @@
 #endif
 
+#if defined( __vtk )
+ END SUBROUTINE palm
+#else
  END PROGRAM palm
+#endif
+
+
Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 4901)
+++ palm/trunk/SOURCE/parin.f90	(revision 1)
@@ -1,113 +1,114 @@
-!> @file parin.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------------------------!
-!
-! Current revisions:
+ SUBROUTINE parin
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
 ! -----------------
-!
+! 
 !
 ! Former revisions:
 ! -----------------
-! $Id$
-! internal switch removed from namelist
-!
-! 4845 2021-01-18 11:15:37Z raasch
-! -use_cmax
-!
-! 4842 2021-01-14 10:42:28Z raasch
-! reading of namelist file and actions in case of namelist errors revised so that statement labels
-! and goto statements are not required any more,
-! deprecated namelists removed
-!
-! 4828 2021-01-05 11:21:41Z Giersch
-! file re-formatted to follow the PALM coding standard
-!
-! 4783 2020-11-13 13:58:45Z raasch
-! bugfix for reading restart data with MPI-I/O (does not work with blockwise I/O)
-!
-! 4680 2020-09-16 10:20:34Z gronemeier
-! Add option to fix date or time of the simulation
-!
-! 4565 2020-06-15 08:30:38Z oliver.maas
-! added pt_surface_heating_rate
-!
-! 4564 2020-06-12 14:03:36Z raasch
-! Vertical nesting method of Huq et al. (2019) removed
-!
-! 4536 2020-05-17 17:24:13Z raasch
-! bugfix for restart data format query
-!
-! 4505 2020-04-20 15:37:15Z schwenkel
-! Add flag for saturation check
-!
-! 4495 2020-04-13 20:11:20Z raasch
-! restart data handling with MPI-IO added
-!
-! 4360 2020-01-07 11:25:50Z suehring
-! removed recycling_yshift
-!
-! 4227 2019-09-10 18:04:34Z gronemeier
-! implement new palm_date_time_mod
-!
-! 4146 2019-08-07 07:47:36Z gronemeier
-! added rotation_angle to initialization_parameters
-!
-! 4191 2019-08-27 15:45:07Z gronemeier
-! bugfix: add recycling_method_for_thermodynamic_quantities to inipar namelist
-!
-! 4183 2019-08-23 07:33:16Z oliver.maas
-! replaced recycle_absolute_quantities by recycling_method_for_thermodynamic_quantities
-!
-! 4182 2019-08-22 15:20:23Z scharf
-! Corrected "Former revisions" section
-!
-! 4176 2019-08-20 14:10:41Z oliver.maas
-! added recycle_absolute_quantities to initialization_parameters namelist
-!
-! 4173 2019-08-20 12:04:06Z gronemeier
-! add vdi_internal_controls
-!
-! 4131 2019-08-02 11:06:18Z monakurppa
-! Allocate hom and hom_sum to allow profile output for salsa variables.
-!
-! 4079 2019-07-09 18:04:41Z suehring
-! +monotonic_limiter_z
-!
-! 4022 2019-06-12 11:52:39Z suehring
-! Change default top boundary condition for pressure to Neumann in offline nesting case
-!
-! 4017 2019-06-06 12:16:46Z schwenkel
-! Introduce alternative switch for debug output during timestepping
-!
-! 3885 2019-04-11 11:29:34Z kanani
-! Changes related to global restructuring of location messages and introduction of additional debug
-! messages
-!
-! 3806 2019-03-21 12:45:50Z raasch
-! additional check for lateral boundary conditions added
-!
-! 3747 2019-02-16 15:15:23Z gronemeier
-! removed setting of parameter region
-!
-! 3746 2019-02-16 12:41:27Z gronemeier
-! Removed most_method
-!
-! 3649 2019-01-02 16:52:21Z suehring
-! Delete debug-print statements
-!
+! $Log: parin.f90,v $
+! Revision 1.57  2007/02/11 13:11:22  raasch
+! Values of environment variables are now read from file ENVPAR instead of
+! reading them with a system call, + NAMELIST envpar
+!
+! Revision 1.56  2006/08/22 14:13:56  raasch
+! +dz_max in inipar
+!
+! Revision 1.55  2006/08/04 14:53:43  raasch
+! +use_upstream_for_tke
+!
+! Revision 1.54  2006/03/17 08:45:44  raasch
+! +skip_time_data_output_av
+!
+! Revision 1.53  2006/02/23 12:46:19  raasch
+! parameters for 2d/3d averaging,
+! +conserve_volume_flow, dissipation_1d, e_min, mixing_length_1d, topography, &
+! wall_heatflux in inipar,
+! +data_output, netcdf_64bit, skip_time_dosp, skip_time_dopr, etc. in d3par,
+! allocation of nanz_2dh and nanz_3d moved to init_3d_model, ebene renamed
+! section, average_period_pr1d removed, average_period_pl1d renamed
+! averaging_interval_pr, dt_average renamed dt_averaging_input_pr,
+! +parameters for single building topography settings
+!
+! Revision 1.52  2005/06/29 10:21:15  steinfeld
+! +ug_surface, ug_vertical_gradient, ug_vertical_gradient_level,
+!  vg_surface, vg_vertical_gradient, vg_vertical_gradient_level in inipar;
+! arrays ug and vg are allocated during initialization runs
+!
+! Revision 1.51  2005/06/26 20:06:26  raasch
+! +cloud_droplets in inipar
+!
+! Revision 1.50  2005/05/18 15:40:49  raasch
+! +netcdf_precision in inipar, +data_output_format in d3par
+!
+! Revision 1.49  2005/04/23 09:35:23  raasch
+! fcl_factor renamed cfl_factor
+!
+! Revision 1.48  2005/03/26 20:42:17  raasch
+! +bc_lr, bc_ns, call_psolver_at_all_substeps, inflow_disturbance_begin, &
+! inflow_disturbance_end, km_damp_max, outflow_damping_width in inipar
+!
+! Revision 1.47  2004/04/30 12:32:06  raasch
+! +grid_matching in inipar, impulse_advec renamed momentum_advec
+!
+! Revision 1.46  2003/10/29 09:03:06  raasch
+! +mg_cycles, mg_switch_to_pe0_level in d3par
+!
+! Revision 1.45  2003/03/16 09:42:23  raasch
+! Two underscores (_) are placed in front of all define-strings
+!
+! Revision 1.44  2003/03/14 13:45:24  raasch
+! +random_generator in inipar
+!
+! Revision 1.43  2003/03/12 16:35:55  raasch
+! Reading of environment variable tasks_per_node moved from poisfft_hybrid
+! to here
+!
+! Revision 1.42  2002/12/19 15:55:31  raasch
+! Saving preliminary process-id-string for opening unit 14 (binary output for
+! restart). Array hom is allocated during first run only, allocation during
+! restart runs will now be done in read_var_list.
+! +dt_restart, restart_time in d3par, STOP statement replaced by call of
+! subroutine local_stop
+!
+! Revision 1.41  2002/04/16 08:10:50  raasch
+! +bc_s_b, bc_s_t, surface_scalarflux, s_surface, s_surface_initial_change,
+! s_vertical_gradient, s_vertical_gradient_level in inipar
+!
+! Revision 1.40  2001/08/21 09:54:27  raasch
+! MPI_COMM_WORLD replaced by comm_palm, +wall_adjustment in inipar
+!
+! Revision 1.39  2001/07/20 13:10:07  raasch
+! +cycle_mg, ngsrb, residual_limit in d3par
+!
+! Revision 1.38  2001/03/30 07:43:55  raasch
+! Translation of remaining German identifiers (variables, subroutines, etc.),
+! namelist d3par can also be omitted in the initial run
+!
+! Revision 1.37  2001/01/29 12:30:26  raasch
+! +passive_scalar in inipar
+!
+! Revision 1.36  2001/01/25 07:17:39  raasch
+! +fft_method, use_surface_fluxes in inipar
+!
+! Revision 1.35  2001/01/02 17:32:13  raasch
+! Unit 11 closed at the end of the subroutine
+!
+! Revision 1.34  2000/12/28 13:24:51  raasch
+! Call of package_parin. dt_dvrp and threshold moved
+! from d3par to other namelists in subroutine package_parin
+!
+! Revision 1.33  2000/04/27 06:55:20  raasch
+! +npex, npey in initial parameter list, comments have to be translated yet,
+! -dt_plisos, dt_plpart, +dt_dvrp, threshold, in run-time parameter list,
+! all comments translated into English, old revision remarks deleted
+!
+! Revision 1.32  2000/04/13 13:03:06  schroeter
+! Erweitern der Parameterlist fuer Wolkenphysik
+!
+! Revision 1.31  2000/01/10  10:05:55  10:05:55  raasch (Siegfried Raasch)
+! +use_ug_for_galilei_tr
+! 
 ! Revision 1.1  1997/07/24 11:22:50  raasch
 ! Initial revision
